import greenfoot.*;
import java.util.List;

/**
 * Write a description of class HeroTank here.
 * 
 * @author (潘威歷 PanWeiLi) 
 * @version (201510081000)
 */
public class HeroTank extends Tank
{
    private int bulletType=0;  //炮彈類型，0是一般，1是超級
    private int iBulletCount=0;//超級炮彈的目前發射存量
    private GreenfootSound rewardsSound; //吃到獎勵的音效
    private GreenfootSound trackSound;  //行走的音效
    private boolean keyDown=false;  //偵測目前是否按下按鍵
    public HeroTank(int angle)
    {
        super(angle);  
        speed=1;  //初始速度設為1
        imgIndex=1;  //行走動畫的影像索引由1開始
        imgString="heroTank/heroTank";  //圖片檔的檔名前半段
        String imgFile=imgString+Integer.toString(imgIndex)+".png";
        GreenfootImage img = new GreenfootImage(imgFile);
        setImage(img);
        gI=getImage();
        fullBlood=45;   //滿血量為45
        blood=fullBlood; //目前血量設定為滿血量
        fireTimer=0;  //開火計時器
        fireRate=60;  //預設開火頻率為1秒1發     
        rewardsSound=new GreenfootSound("rewards-get.mp3");
        fireSound=new GreenfootSound("tank-firing.mp3");
        explosionSound=new GreenfootSound("herotank_explosion.mp3");
        trackSound=new GreenfootSound("vehicle.mp3");
        bk=getWorldOfType(LevelOne.class);
    }
    
    /**
     * 利用方向鍵操作主角戰車的行動
     * use arrow key to control tank moving
     */
    public void tankMove()
    {
        if(Greenfoot.isKeyDown("left") || Greenfoot.isKeyDown("a"))
        {
            setImage(setAnimator(imgString,imgIndex));
            setRotation(180);
            if (checkFront())
            {
                move(speed);
            }
            if(keyDown==false)
            {
                trackSound.play();
                keyDown=true;
            }
        }
        else if (Greenfoot.isKeyDown("right") || Greenfoot.isKeyDown("d"))
        {
            setImage(setAnimator(imgString,imgIndex));
            setRotation(0);
            if (checkFront())
            {
                move(speed);
            }
            if(keyDown==false)
            {
                trackSound.play();
                keyDown=true;
            }
        }
        else if (Greenfoot.isKeyDown("up") || Greenfoot.isKeyDown("w"))
        {
            setImage(setAnimator(imgString,imgIndex));
            setRotation(270);
            if (checkFront())
            {
                move(speed);
            }
            if(keyDown==false)
            {
                trackSound.play();
                keyDown=true;
            }
        }
        else if (Greenfoot.isKeyDown("down") || Greenfoot.isKeyDown("s"))
        {
            setImage(setAnimator(imgString,imgIndex));
            setRotation(90);
            if (checkFront())
            {
                move(speed);
            }
            if(keyDown==false)
            {
                trackSound.play();
                keyDown=true;
            }
        }
        else
        {
            keyDown=false;
            trackSound.stop();
        }
    }
    
    /**
     * 戰車開火
     */
    public void tankFire()
    {
        angle=getRotation();  //炮彈發射的角度要與坦克面對的方向一致
        if (fireTimer!=0)  //當計時器還沒歸零時，不能開火
        {
            fireTimer--;   //計時器繼續倒數
        }
        if (Greenfoot.isKeyDown("space"))  //按下空白鍵時
        {
            if(fireTimer==0)  //如果計時器已經歸零，才可以開火
            {
                Bullet b;
                if (bulletType==0)  //0是一般炮彈
                {
                    b=new ComBullet(angle);
                }
                else  //如果是超級炮彈
                {
                    b=new IronBullet(angle);
                    iBulletCount--;
                }
                switch(angle)  //設定炮彈的初始位置
                {
                    case 0:
                        bk.addObject(b,getX()+gI.getWidth()/2-5,getY());
                        break;
                    case 90:
                        bk.addObject(b,getX(),getY()+gI.getHeight()/2-5);
                        break;
                    case 180:
                        bk.addObject(b,getX()-gI.getWidth()/2+5,getY());
                        break;
                    case 270:
                        bk.addObject(b,getX(),getY()-gI.getHeight()/2+5);
                        break;
                    default:
                        break;
                }
                if (iBulletCount==0)  //如果超級炮彈已經耗盡
                {
                    bulletType=0;     //則將炮彈類型改回一般炮彈
                }
                fireSound.play();
                fireTimer=fireRate;  //每開火一次，則重置開火倒數計時器，限定開火頻率
            }
        }
    }
 
    /**
     * 減少血量，血量小於零則遊戲結束。
     */
    public void reduceBlood(int pow)
    {
        blood-=pow;
        if(blood<=0)
        {
            explosionSound.play();
            bk.gameOver();
        }
    }
    
    /**
     * 控制超級子彈開火
     */
    public void iBulletSet()
    {
        bulletType=1;
        iBulletCount=3;
    }
    
    /**
     * 偵測碰到哪些類別的物件
     */
    public void detectTouching()
    {
        if(isTouching(IronBaseWall.class))  //如果吃到基地保護牆獎勵
        {
            bk.showMessage("Iron Wall",getX(),getY());  //出現IronWall的往上漸層消失的文字效果
            bk.setIronBaseWall();  //執行基地保護牆的效果
            removeTouching(IronBaseWall.class);  //移除獎勵
            rewardsSound.play();
        }
        else if(isTouching(IronBullets.class))
        {
           iBulletSet();
           bk.showMessage("!!Pow UP!!",getX(),getY());
           removeTouching(IronBullets.class);
           rewardsSound.play();
        }
        else if(isTouching(AirSupply.class))
        {
            bk.showMessage("Bomber+1",getX(),getY());
            bk.addBomber();
            removeTouching(AirSupply.class);
            rewardsSound.play();
        }
        else if(isTouching(Medic.class))
        {
            //吃到補血就加15滴，但不能超過滿血45滴
            bk.showMessage("blood+15",getX(),getY());
            blood+=15;
            if(blood>45)
            {
                blood=45;
            }
            removeTouching(Medic.class);
            rewardsSound.play();
        }
        else if(isTouching(RateUp.class))
        {
            bk.showMessage("Rate Up!!",getX(),getY());
            fireRate-=15;
            //頻率最高半秒一發
            if(fireRate<=30)
            {
                fireRate=30;
            }
            removeTouching(RateUp.class);
            rewardsSound.play();
        }
        else if(isTouching(SpeedUp.class))
        {
            bk.showMessage("Speed Up!",getX(),getY());;
            speed+=1;
            //速度最高到2
            if(speed>=2)
            {
                speed=2;
            }
            removeTouching(SpeedUp.class);
            rewardsSound.play();
        }
        else
        {
            return;
        }
    }
    
    /**
     * Act - do whatever the HeroTank wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        tankMove();
        tankFire();
        detectTouching();
    }    
}
