import greenfoot.*;
import java.util.List;
/**
 * Write a description of class Background here.
 * 
 * @author (建國高中資訊組潘威歷 PanWeiLi) 
 * @version (20160119)
 */
public class LevelOne extends World
{
    /**
       場景設定:
       0:沒有磚塊，1:迷宮磚塊，2:鋼鐵磚塊，3:邊界磚塊
    **/
    private int brickArray[][]={
        {3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3},
        {3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3},
        {3,0,1,1,0,0,1,1,1,1,1,1,0,0,1,1,0,3},
        {3,0,1,1,0,0,1,1,1,1,1,1,0,0,1,1,0,3},
        {3,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,3},
        {3,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,3},
        {3,0,1,1,0,1,1,1,2,2,1,1,1,0,1,1,0,3},
        {3,2,2,0,0,0,0,0,0,0,0,0,0,0,0,2,2,3},
        {3,1,1,0,1,1,1,1,0,0,1,1,1,1,0,1,1,3},
        {3,1,1,0,1,1,0,0,0,0,0,0,1,1,0,1,1,3},
        {3,1,1,0,1,1,0,1,1,1,1,0,1,1,0,1,1,3},
        {3,1,1,0,1,1,0,1,0,0,1,0,1,1,0,1,1,3},
        {3,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,3},
        {3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3}
    };
    //敵方坦克重生點的位置
    private int respawnPos[][]={
        {225,125},
        {675,125},
        {75,325},
        {825,325}
    };
    
    private HeroTank hT=new HeroTank(270); //我方坦克
    private Base b=new Base(); //我方基地
    private int trashTankAmount=20; //敵方坦克數量
    private int trashAppearTime=500; //敵方坦克再生的時間
    private int trashAppearTimer=trashAppearTime; //敵方坦克再生的倒數計時器
    private int bomberAmount=3; //轟炸機的初始及最大值
    private int bomberTime=180; //每呼叫完一次需要再隔三秒才能用
    private int bomberTimer=0; //兩次轟炸之間的倒數計時器
    private int resetBaseWallTimer=0; //基地保護牆的持續時間
    private boolean resetBaseWall=false; //若基地保護牆的狀態，若原來有缺口，保護牆只要啟動後，當保護牆消失時，則原本的基地牆應恢復原來的完整狀態
    private GreenfootSound bkSound; //背景音軌檔

    /**
     * Constructor for objects of class Background.
     * 
     */    
    public LevelOne()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(900, 700, 1,false);
        setBrick();
        setPaintOrder(Messages.class,Bomber.class,Blood.class,Tank.class);  //排定場景上各物件的順序，以免不對的圖層影響遊戲效果
        addObject(hT,325,625);
        addObject(b,getWidth()/2,600);
        int angle = Greenfoot.getRandomNumber(4);
        addObject(new TrashTank(90*angle),225,125);
        trashTankAmount--;
        angle = Greenfoot.getRandomNumber(4);
        addObject(new TrashTank(90*angle),675,125);
        trashTankAmount--;
    }
    
    /**
     * 將磚塊置入指定位置
     * put bricks to default postion
     */
    private void setBrick()
    {
        for(int i=0;i<brickArray.length;i++)
        {
            for(int j=0;j<brickArray[0].length;j++)
            {
                switch (brickArray[i][j])
                {
                    case 1:
                        addObject(new ComBrick(),j*50+25,i*50+25);
                        break;
                    case 2:
                        addObject(new IronBrick(),j*50+25,i*50+25);
                        break;
                    case 3:
                        addObject(new BorderBrick(),j*50+25,i*50+25);
                        break;
                    default:
                        break;
                }
            }
        }
    }
    
    /**
     * 回傳我方坦克之物件，因為hT為private屬性，所以必須使用public方法，讓其他類別便於取用
     */
    public HeroTank getHT()
    {
        return hT;
    }
    
    /**
     * 重生敵方坦克
     */
    private void respawnTrashTank()
    {
        if(trashAppearTimer!=0)  //若倒數計時器尚未為零
        {
            trashAppearTimer--;  //繼續遞減
        }
        else
        {
            if(trashTankAmount!=0)  //若仍有尚未出場的敵方戰車
            {
               int angle = Greenfoot.getRandomNumber(4);  //隨機產生面對的角度
               addObject(new TrashTank(90*angle),respawnPos[angle][0],respawnPos[angle][1]);  //在四個重生點隨機選一個點產生敵方戰車
               trashAppearTimer=trashAppearTime;  //重設計數器
               trashTankAmount--;
            }
        }
    }
    
    /**
     * 吃到寶物要出現相對應的文字漸淡訊息
     */
    public void showMessage(String img,int x,int y)
    {
        Messages msg=new Messages(img);
        addObject(msg,x,y);
    }
    
    /**
     * 啟動基地防衛機制
     */
    public void setIronBaseWall()
    {
        resetBaseWall=true;      //開啟基地保護牆狀態
        resetBaseWallTimer=600;  //持續時間為10秒
        //基地周圍8塊磚塊要先移除，再擺上鋼鐵磚塊
        List l = getObjectsAt(375,525,ComBrick.class);
        if(l.size()!=0)
        {
            removeObject((Actor)l.get(0));
        }
        addObject(new IronBrick(),375,525);
        l = getObjectsAt(375,575,ComBrick.class);
        if(l.size()!=0)
        {
            removeObject((Actor)l.get(0));
        }
        addObject(new IronBrick(),375,575);
        l = getObjectsAt(375,625,ComBrick.class);
        if(l.size()!=0)
        {
            removeObject((Actor)l.get(0));
        }
        addObject(new IronBrick(),375,625);
        l = getObjectsAt(425,525,ComBrick.class);
        if(l.size()!=0)
        {
            removeObject((Actor)l.get(0));
        }
        addObject(new IronBrick(),425,525);
        l = getObjectsAt(475,525,ComBrick.class);
        if(l.size()!=0)
        {
            removeObject((Actor)l.get(0));
        }
        addObject(new IronBrick(),475,525);
        l = getObjectsAt(525,525,ComBrick.class);
        if(l.size()!=0)
        {
            removeObject((Actor)l.get(0));
        }
        addObject(new IronBrick(),525,525);
        l = getObjectsAt(525,575,ComBrick.class);
        if(l.size()!=0)
        {
            removeObject((Actor)l.get(0));
        }
        addObject(new IronBrick(),525,575);
        l = getObjectsAt(525,625,ComBrick.class);
        if(l.size()!=0)
        {
            removeObject((Actor)l.get(0));
        }
        addObject(new IronBrick(),525,625);
    }
    
    /**
     * 當基地保護牆持續時間結束時，將基地周圍換為一般普通磚塊(迷宮磚塊)
     */
    public void resetBaseWall()
    {
        List l = getObjectsAt(375,525,IronBrick.class);
        removeObject((Actor)l.get(0));
        addObject(new ComBrick(),375,525);
        l = getObjectsAt(375,575,IronBrick.class);
        removeObject((Actor)l.get(0));
        addObject(new ComBrick(),375,575);
        l = getObjectsAt(375,625,IronBrick.class);
        removeObject((Actor)l.get(0));
        addObject(new ComBrick(),375,625);
        l = getObjectsAt(425,525,IronBrick.class);
        removeObject((Actor)l.get(0));
        addObject(new ComBrick(),425,525);
        l = getObjectsAt(475,525,IronBrick.class);
        removeObject((Actor)l.get(0));
        addObject(new ComBrick(),475,525);
        l = getObjectsAt(525,525,IronBrick.class);
        removeObject((Actor)l.get(0));
        addObject(new ComBrick(),525,525);
        l = getObjectsAt(525,575,IronBrick.class);
        removeObject((Actor)l.get(0));
        addObject(new ComBrick(),525,575);
        l = getObjectsAt(525,625,IronBrick.class);
        removeObject((Actor)l.get(0));
        addObject(new ComBrick(),525,625);
    }
    
    /**
     * 判斷基地鋼鐵牆是不是已經到時限了
     */
    public void checkResetBaseWall()
    {
        if(resetBaseWall)  //如果目前基地保護牆仍在無敵狀態中
        {
            resetBaseWallTimer--;  //繼續倒數
            if(resetBaseWallTimer==0)  //當計時器歸零時
            {
                resetBaseWall();    //將基地重設為原本的一般磚塊狀態
                resetBaseWall=false;
            }
        }
    }
    
    /**
     * 吃到增加轟炸機的寶物
     */
    public void addBomber()
    {
        if(bomberAmount<3)
        {
            bomberAmount++;
        }
    }
    
    /**
     * 按下B鍵呼叫轟炸機對地密接支援
     */
    public void callBomber()
    {
        if(bomberTimer!=0)   //當倒數計時器尚未歸零時
        {
             bomberTimer--;  //繼續遞減
        }
        if (Greenfoot.isKeyDown("b") && bomberTimer==0 && bomberAmount>0)   //按下B鍵同時計時器已經歸零時才可以繼續呼叫轟炸機
        {
            addObject(new Bomber(270),450,900);
            bomberAmount--;
            bomberTimer=bomberTime;
        }
    }
    /**
     * 將遊戲開始後要呈現的相關訊息，執行順序為建構子完成之後
     */
    public void started()
    {
        addObject(new iTrashTank(),380,25);   //設定敵方坦克圖示(正上方)
        addObject(new iBomber(),470,25);   //設定轟炸機圖示(正上方)
        bkSound=new GreenfootSound("background.mp3");  //設定背景音樂
        bkSound.setVolume(40);    //設定音量
        bkSound.playLoop();       //持續播放背景音樂
    }
    
    /**
     * 呈現目前遊戲資訊，修正尚未上場的敵方戰車數與玩家所能呼叫轟炸機的次數
     */
    public void showInfo()
    {
        String info="× "+ trashTankAmount + "          × " + bomberAmount;
        showText(info,getWidth()/2,25);
    }
    
    /**
     * 遊戲結束
     */
    public void gameOver()
    {
        showText("GameOver!!",getWidth()/2,getHeight()/2);
        bkSound.play();
    }
    
    /**
    * 完成任務完成訊息(破關)
    */
    public void missionClear()
    {
        List l=getObjects(TrashTank.class);  //取得目前尚在場上的敵方戰車數
        if(l.size()==0 && trashTankAmount==0)  //若場上敵方戰車數與尚未上場的戰車數皆為0，表示已經破關完成。
        {
           showText("Mission Complete!!",getWidth()/2,getHeight()/2);
           Greenfoot.stop(); 
        }
    }
    
    /**
     * 每個回合都要做以下幾件事:
     * 1.確認是否隨機產生敵方坦克
     * 2.確認是否重新設定基地保護牆
     * 3.確認是否呼叫轟炸機
     * 4.修正目前還未上場的敵方戰車數與剩餘呼叫轟炸機數量
     * 5.確認是否已破關
     */
    public void act()
    {
        respawnTrashTank();
        checkResetBaseWall();
        callBomber();
        showInfo();
        missionClear();
    }
}
