import greenfoot.*;

/**
 * Write a description of class Tank here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Tank extends Actor
{
    protected int speed;    //坦克目前的速度
    protected GreenfootImage gI;  //物件目前的影像
    protected int imgIndex;     //影像檔的Index，用來製作坦克行走動畫之用
    protected String imgString; //影像檔的檔名
    protected LevelOne bk;   //紀錄物件目前所在場景
    protected int angle;     //坦克目前面對的角度
    protected int distance;  //紀錄坦克目前行走的累積距離，可用來判斷是否該進行轉向判斷
    protected int blood;     //紀錄戰車目前血量
    protected int fullBlood; //紀錄戰車滿血量
    protected int fireTimer; //開火計時器
    protected int fireRate;  //開火頻率
    protected GreenfootSound fireSound;  //開火的聲音
    protected GreenfootSound explosionSound;  //爆炸的聲音
    /**
     * Tank建構子,angle負責處理坦克生成時所面向的角度
     * Tank constructor
     */
    public Tank(int angle)
    {
        setRotation(angle);
        speed=1;
        gI=getImage();
    }

    /**
     * 確認前方有無障礙物
     * detect obstacle
     */
    public boolean checkFront()
    {
        angle=getRotation();  //取得目前坦克面對的方向
        Actor test1;    //左前方物件
        Actor test2;    //右前方物件
        boolean result=true;  //預設為前方有障礙物
        GreenfootImage gI=getImage();  //取得目前坦克所使用的影像
        if (angle==0)  //向右
        {
            test1=getOneObjectAtOffset(gI.getWidth()/2+speed, gI.getHeight()/2, Brick.class);  
            test2=getOneObjectAtOffset(gI.getWidth()/2+speed, -(gI.getHeight()/2), Brick.class);
            if(test1!=null || test2!=null)
            {
                result=false;
            }
        }
        else if(angle==90)//向下
        {
            test1=getOneObjectAtOffset(-(gI.getWidth()/2), gI.getHeight()/2+speed, Brick.class);
            test2=getOneObjectAtOffset(gI.getWidth()/2, gI.getHeight()/2+speed, Brick.class);
            if(test1!=null || test2!=null)
            {
                result=false;
            }
        }
        else if(angle==180)//向左
        {
            test1=getOneObjectAtOffset(-(gI.getWidth()/2+speed), gI.getHeight()/2, Brick.class);
            test2=getOneObjectAtOffset(-(gI.getWidth()/2+speed), -(gI.getHeight()/2), Brick.class);
            if(test1!=null || test2!=null)
            {
                result=false;
            }
        }
        else if(angle==270)//向上
        {
            test1=getOneObjectAtOffset(-(gI.getWidth()/2), -(gI.getHeight()/2+speed), Brick.class);
            test2=getOneObjectAtOffset(gI.getWidth()/2, -(gI.getHeight()/2+speed), Brick.class);
            if(test1!=null || test2!=null)
            {
                result=false;
            }
        }
        else
        {
            result=true;
        }
        return result;
    }
    
    /**
     * 戰車的血量
     */
    protected void addedToWorld(World world)
    {
        bk=getWorldOfType(LevelOne.class);
        bk.addObject(new Blood(this),getX(),getY()+26);
    }
    
    /**
     * 減少血量
     */
    public void reduceBlood(int pow)
    {
        blood-=pow;
    }
    
    /**
     * 回傳目前血量
     */
    public int getBlood()
    {
        return blood;
    }
    
    /**
     * 回傳滿血量
     */
    public int getFullBlood()
    {
        return fullBlood;
    }
    
    /**
     * 回傳開火計時器
     */
    public int getFireTimer()
    {
        return fireTimer;
    }
    /**
     * 回傳開火頻率
     */
    public int getFireRate()
    {
        return fireRate;
    }
    /**
     * 計算掉寶的機率
     */
    public void generateRewards()
    { 
        LevelOne bk = getWorldOfType(LevelOne.class);
        int r=Greenfoot.getRandomNumber(100);
        if(r>95)
        {
            bk.addObject(new AirSupply(300),getX(),getY());
        }
        else if(r>90)
        {
            bk.addObject(new IronBullets(300),getX(),getY());
        }
        else if(r>80)
        {
            bk.addObject(new IronBaseWall(600),getX(),getY());
        }
        else if (r>70)
        {
            bk.addObject(new Medic(300),getX(),getY());
        }
        else if (r>65)
        {
            bk.addObject(new RateUp(300),getX(),getY());
        }
        else if (r>60)
        {
            bk.addObject(new SpeedUp(300),getX(),getY());
        }
        else
        {
            return;
        }
    }
    
    /**
     * 設定動畫格數
     */
    public GreenfootImage setAnimator(String imgString, int imgIndex)
    {
        String imgFile=imgString+Integer.toString(this.imgIndex)+".png";
        GreenfootImage img = new GreenfootImage(imgFile);
        if(imgIndex==7)
        {
            this.imgIndex=1;
        }
        else
        {
            this.imgIndex++;
        }
        return img;
    }  
}
