import greenfoot.*;

/**
 * Write a description of class TrashTank here.
 * 
 * @臺北市建國高中資訊組潘威歷 
 * @20160120
 */
public class TrashTank extends Tank
{
    private int dirTimer=90+Greenfoot.getRandomNumber(4)*60;   //轉向判定計時器，每隔一段時間要進行轉向判定，決定是否進行轉向
    private int pow;  //坦克本身的撞擊力道
    private int stopTimer=0;  //停止前進計時器，讓坦克進行轉向判定時可以有稍微暫停的效果

    public TrashTank(int angle)
    {
        super(angle);
        speed=1;
        imgIndex=1;
        imgString="enemyTank/enemyTank";
        String imgFile=imgString+Integer.toString(imgIndex)+".png";
        GreenfootImage img = new GreenfootImage(imgFile);
        setImage(img);
        gI=getImage();
        fullBlood=30;  //敵方坦克設定的滿血量為30
        blood=fullBlood;
        pow=blood;  //坦克的撞擊力道會等目前的血量值，血量愈大，撞擊力道愈大(這是用來判定當敵我坦克相撞時所造成的損害)
        fireTimer=0;   //開火倒數計時器設定為0
        fireRate=120;  //開火頻率設定為2秒
        bk=getWorldOfType(LevelOne.class);
        fireSound=new GreenfootSound("enemy-tank-firing.mp3");
        fireSound.setVolume(30);
        explosionSound=new GreenfootSound("enemy-tank-explosion.mp3");
    }

    /**
     * 敵方坦克的移動方式
     */
    public void tankMove()
    {
        if(stopTimer==0)  //如果目前停止前進計時器為0
        {
            if(checkFront())  //如果可以前行就繼續前行
            {
                setImage(setAnimator(imgString,imgIndex));
                move(speed);
            }
            else
            {
                setImage(setAnimator(imgString,imgIndex));
                setRotation(Greenfoot.getRandomNumber(4)*90);
            }
        }
        else  //如果停止前進計時器尚未歸零，則原地停止等待
        {
           stopTimer--; 
        }
    }
    
    /**
     * 用來處理轉向事宜，每隔一段時間要進行一次轉向判定，時間由dirTimer控制
     */
    public void changeDirection()
    {
        if (dirTimer!=0)   //如果轉向判定計時器尚未歸零
        {
            dirTimer--;   //繼續遞減
        }
        else
        {
            stopTimer=60;  //停止前進倒數計時器設定為1秒
            setImage(setAnimator(imgString,imgIndex));
            setRotation(Greenfoot.getRandomNumber(4)*90);
            dirTimer=90+Greenfoot.getRandomNumber(4)*60;
        }
    }
    
    /**
     * 坦克自動開火的頻率
     */
    public void tankFire()
    {
        angle=getRotation();
        if (fireTimer!=0)
        {
            fireTimer--;
        }
        else
        {
            switch(angle)
            {
                case 0:
                    bk.addObject(new TcomBullet(angle),getX()+gI.getWidth()/2-5,getY());
                    break;
                case 90:
                    bk.addObject(new TcomBullet(angle),getX(),getY()+gI.getHeight()/2-5);
                    break;
                case 180:
                    bk.addObject(new TcomBullet(angle),getX()-gI.getWidth()/2+5,getY());
                    break;
                case 270:
                    bk.addObject(new TcomBullet(angle),getX(),getY()-gI.getHeight()/2+5);
                    break;
                default:
                    break;
             }
             fireSound.play();
             fireTimer=fireRate;
        }
    }
    
    /**
     * 檢測是否撞擊到我方坦克
     */
    public void detectHeroTank()
    {
        HeroTank t =(HeroTank)getOneIntersectingObject(HeroTank.class);
        if(t!=null)
        {
            t.reduceBlood(pow);
            reduceBlood(pow);  //自己也被主角坦克撞到，所以也要扣血
        }
    }
    
    /**
     * 減少血量，血量小於零隨機掉寶。
     */
    public void reduceBlood(int pow)
    {
        blood-=pow;
        this.pow=blood;  //將破壞力設定為與目前血量一樣
        if(blood<=0)
        {
            explosionSound.play();
            generateRewards();
        }
    }
    
    /**
     * Act - do whatever the TrashTank wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        changeDirection();
        tankFire();
        tankMove();
        detectHeroTank();
    }    
}
